--EyeRecord Version 2.0.3
--
--EyeRecord is a little script to program EyeTV with the help of TV-Browser. (Today TV-Browser only support german tv-stations.)
--
--Script made by Jan Kampling
--http://www.macmediacenter.de
--Licenesed under GNU General Public License, Free Software Foundation http://creativecommons.org/licenses/GPL/2.0/
--
--Uses code from TV2ical from Jan Weis and some code from Michael Steder Thx.
--
--
-- Call:
-- for example (eyetv programing)
-- make eyetv entry: set{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
-- delete eyetv entry: del{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
--
-- EyeTV Controllings
-- stop recording: stop{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
-- pause/play: pause{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
-- switch to station: switch{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
-- switch to station (fullscreen): switchfull{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
-- switch to station and record: switchrec{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
-- switch to stattion and record (fullscreen): switchfullrec{channel_name}{start_year}-{start_month}-{start_day}{start_hour}:{start_minute}{end_year}-{end_month}-{end_day}{end_hour}:{end_minute}{title}20{short_info}{description}{length_sec}{channel_name_external}{original_episode}eyetv
--
--
--
-- debugging stuff
--set myParams to "/tmp/toEyeTV911.txt"
-- debugging stuff end 
--
--
-- sub-routines
--
--
on getdateForISOdate(theISODate, theISOTime)
	local myDate
	-- converts an ISO format (YYYY-MM-DD) and time to a date object
	set monthConstants to {January, February, March, April, May, June, July, August, September, October, November, December}
	
	set theISODate to (stringToList from (theISODate) for "-")
	
	set myDate to date theISOTime
	
	tell theISODate
		set year of myDate to item 1
		set month of myDate to item (item 2) of monthConstants
		set day of myDate to item 3
	end tell
	
	return myDate
end getdateForISOdate
--
on isoTime from dateObj
	tell dateObj
		return text 2 thru 3 of ((100 + ((its time) div hours as integer)) as string) 
			& ":" & text 2 thru 3 of ((100 + ((its time) mod hours div minutes)) as string) 
			& ":" & text 2 thru 3 of ((100 + ((its time) mod minutes)) as string)
	end tell
end isoTime
--
on ListToString from theList for myDelimiters
	tell AppleScript
		
		-- Diese Funktion ermglicht das Unterteilen von Strings anhand beliebiger Zeichen
		-- AppleScript wird veranlat Listeneintrge mit myDelimiters (z.B. ";") als Trennzeichen zu einem Text zu verbinden	
		set theSavedDelimiters to AppleScript's text item delimiters
		set text item delimiters to myDelimiters
		
		set outString to theList as text
		
		
		-- Um mglichen Probleme in diesem und anderen Scipts aus dem Weg zu gehen, 
		-- wird alles wieder in den vorherigen Zustand gebracht
		-- Restore the text item delimiters (in the interests of being a good citizen).
		set text item delimiters to theSavedDelimiters
		
		return outString
	end tell
end ListToString
--
on stringToList from theString for myDelimiters
	tell AppleScript
		
		-- Diese Funktion ermglicht das Unterteilen von Strings anhand beliebiger Zeichen
		-- AppleScript wird veranlat Text anhand von myDelimiters (z.B. ";") in Einzelteile zu zerlegen	
		set theSavedDelimiters to AppleScript's text item delimiters
		set text item delimiters to myDelimiters
		
		set outList to text items of theString
		
		
		-- Um mglichen Probleme in diesem und anderen Scipts aus dem Weg zu gehen, 
		-- wird alles wieder in den vorherigen Zustand gebracht
		-- Restore the text item delimiters (in the interests of being a good citizen).
		set text item delimiters to theSavedDelimiters
		
		return outList
	end tell
end stringToList
--
on isoDate from dateObj
	-- isoDate - yyyy-mm-dd - for AS 1.9.2 or higher
	-- Richard Morton & Nigel Garvey 2004
	tell dateObj
		return (its year as string) & "-" & 
			text 2 thru 3 of ((100 + (its month as integer)) as string) 
			& "-" & text 2 thru 3 of ((100 + (its day)) as string)
	end tell
end isoDate
--
-- this sub-routine is used to decode a three-character hex string
on decode_chars(these_chars)
	copy these_chars to {indentifying_char, multiplier_char, remainder_char}
	set the hex_list to "123456789ABCDEF"
	if the multiplier_char is in "ABCDEF" then
		set the multiplier_amt to the offset of the multiplier_char in the hex_list
	else
		set the multiplier_amt to the multiplier_char as integer
	end if
	if the remainder_char is in "ABCDEF" then
		set the remainder_amt to the offset of the remainder_char in the hex_list
	else
		set the remainder_amt to the remainder_char as integer
	end if
	set the ASCII_num to (multiplier_amt * 16) + remainder_amt
	return (ASCII character ASCII_num)
end decode_chars
--
-- this sub-routine is used to decode text strings
on decode_text(this_text)
	set flag_A to false
	set flag_B to false
	set temp_char to ""
	set the character_list to {}
	repeat with this_char in this_text
		set this_char to the contents of this_char
		if this_char is "%" then
			set flag_A to true
		else if flag_A is true then
			set the temp_char to this_char
			set flag_A to false
			set flag_B to true
		else if flag_B is true then
			set the end of the character_list to 
				my decode_chars(("%" & temp_char & this_char) as string)
			set the temp_char to ""
			set flag_A to false
			set flag_B to false
		else
			set the end of the character_list to this_char
		end if
	end repeat
	return the character_list as string
end decode_text
--
on replace_chars(this_text, search_string, replacement_string)
	set AppleScript's text item delimiters to the search_string
	set the item_list to every text item of this_text
	set AppleScript's text item delimiters to the replacement_string
	set this_text to the item_list as string
	set AppleScript's text item delimiters to ""
	return this_text
end replace_chars
--
--
-- functions for main script
--
--
on eyetvprogramming(myMode, myStartDate, myLength, myTitle, myDescription, myEpisodeinfo, myChannelnumber)
	tell application "EyeTV"
		try
			launch -- apps can't receive the run event except at startup, from the Finder, so this causes an error 
		on error -- when an error happens, do nothing! 
		end try
		--
		-- MODE record Transmisson 
		--
		if myMode = "set" then
			--display dialog (myStartDate as string) & myLength & myTitle & myChannelnumber buttons {"OK"} default button 1
			make new program with properties {start time:date (myStartDate as string), duration:myLength, title:myTitle, description:myDescription, episode:myEpisodeinfo, channel number:myChannelnumber}
			return the result
			--
			-- MODE delete transmisson
			--
		else if myMode = "del" then
			repeat with transmission in programs
				--	display dialog (channel number of transmission as string) & (title of transmission) & (start time of transmission) buttons {"OK"} default button 1	
				if title of transmission = myTitle then
					if channel number of transmission = myChannelnumber then
						if (start time of transmission) = myStartDate then
							delete transmission
						end if
					end if
				end if
			end repeat
			
			--
			-- MODE test
			--
		else if myMode = "switch" then
			channel_change channel number myChannelnumber
		else if myMode = "switchfull" then
			channel_change channel number myChannelnumber
			enter full screen
		else if myMode = "switchrec" then
			channel_change channel number myChannelnumber
			start recording
		else if myMode = "switchfullrec" then
			channel_change myChannelnumber
			enter full screen
			start recording
		else if myMode = "stop" then
			stop recording
		else if myMode = "pause" then
			playpause
		else if myMode = "play" then
			play
		end if
	end tell
end eyetvprogramming
--
on growlinfo(myProgMode, myMode, myTitle, myStartDate)
	set myApp to ""
	
	tell application "System Events" to set GrowlRunning to ((application processes whose (name is equal to "GrowlHelperApp")) count)
	
	if GrowlRunning  1 then
		try
			set myApp to "GrowlHelperApp"
			-- Inits
			set appName to "\"EyeRecord Notification Script\""
			set notificationName to "\"EyeRecord Notification\""
			set notifs to "{\"EyeRecord Notification\"}"
			-- end Inits
			-- Register GrowlNotification 
			set myrunscript to "register as application " & appName & " all notifications " & notifs & " default notifications " & notifs & " icon of application \"EyeTV\""
			tell application myApp to run script myrunscript
			-- end Register GrowlNotification
			-- Set output
			if myProgMode is "eyetv" then
				set myGrowlProginfo to "EyeTV"
			end if
			if myMode is "set" then
				set myGrowlModeinfo to " created"
			else if myMode is "del" then
				set myGrowlModeinfo to " deleted"
			else
				set myGrowlModeinfo to "null"
			end if
			-- End set output
			-- Do Growlnotification
			if myGrowlModeinfo is not "null" then
				set myDescription to myTitle & ": " & myStartDate
				set myGrowlTitle to "Entry in " & myGrowlProginfo & myGrowlModeinfo
				set myrunscript to "notify with name " & notificationName & " application name " & appName & " title " & "\"" & myGrowlTitle & "\"" & " description " & "\"" & myDescription & "\""
				tell application myApp to run script myrunscript
			end if
			-- End do Growlnotification
		end try
	end if
end growlinfo
--
--
-- main script
--
--
-- start inits
set myParams to POSIX file myParams

try
	set myParams to read myParams as class utf8
end try

if myParams is not "" then
	set myParams to replace_chars(myParams, "\\", "")
	set myParams to stringToList from myParams for ""
else
	return "parameter error"
end if
if (count of items of myParams) < 14 then
	return "too few parameters"
end if
--
--
--
-- time conversions in this script may seem a bit complicated. This is due to a) limitations in AppleScript and b) the fact that the formats in the international preferences (localisation) influences the way "date" works. we have to work around this to guarantee for the script to work on different configurations
set myProgMode to item 14 of myParams as string
set myStartDate to getdateForISOdate(item 3 of myParams, item 4 of myParams)
set myEndDate to getdateForISOdate(item 5 of myParams, item 6 of myParams)
set myMode to item 1 of myParams as string
set mySummary to decode_text(item 2 of myParams) & "" & decode_text(item 7 of myParams)
if (item 10 of myParams as string) is "null" then
	set myDescription to decode_text(item 9 of myParams)
else
	set myDescription to decode_text(item 9 of myParams) & "" & decode_text(item 10 of myParams)
end if
set myLength to item 11 of myParams as number
set myChannelnumber to item 12 of myParams as number
set myChannelName to decode_text(item 2 of myParams) of myParams
set myTitle to decode_text(item 7 of myParams)
set myEpisodeinfo to decode_text(item 13 of myParams)
set myRecurrence to ""
try
	set fuzzyTime to (item 8 of myParams as number) * minutes
on error
	set fuzzyTime to 20 * minutes
end try
-- end inits
--
-- start functions
--
--
if myProgMode is "eyetv" then
	eyetvprogramming(myMode, myStartDate, myLength, myTitle, myDescription, myEpisodeinfo, myChannelnumber)
	growlinfo(myProgMode, myMode, myTitle, myStartDate)
end if